;;; module-haskell.el

(use-package haskell
  :mode (("\\.hs$" . haskell-mode)
         ("\\.ghci$" . ghci-script-mode)
         ("\\.cabal$" . haskell-cabal-mode))
  :interpreter (("runghc" . haskell-mode)
                ("runhaskell" . haskell-mode))
  :init
  (define-repl! haskell-mode switch-to-haskell)
  (add-hook! haskell-mode '(interactive-haskell-mode flycheck-mode))
  :config
  (add-to-list 'completion-ignored-extensions ".hi"))

(use-package inf-haskell
  :commands (inferior-haskell-mode inf-haskell-mode switch-to-haskell)
  :init (evil-set-initial-state 'inferior-haskell-mode 'emacs)
  :config
  (define-key inf-haskell-mode-map (kbd "ESC ESC") 'narf/popup-close))

(provide 'module-haskell)
;;; module-haskell.el ends here
